﻿#include "GameMain.h"
#include <stdio.h>

GameMain::GameMain(void)
{
}
GameMain::~GameMain(void)
{
}

void GameMain::OnInit()
{
	RECT rect;
	GetClientRect( m_hWnd, &rect );

	D3DVIEWPORT9 vp = {0, 0, rect.right - rect.left, rect.bottom - rect.top, 0.0f, 1.0f};

	m_Eye.x = 5.0f;
	m_Eye.y = 0.0f;
	m_Eye.z = -20.0f;
 
	m_At.x = 0.0f;
	m_At.y = 0.0f;
	m_At.z = 0.0f;
 
	m_Up.x = 0.0f;
	m_Up.y = 1.0f;
	m_Up.z = 0.0f;

	D3DXMatrixLookAtLH( &m_matView, &m_Eye, &m_At, &m_Up );
	pd3dDevice->SetTransform( D3DTS_VIEW, &m_matView );

	D3DXMatrixPerspectiveFovLH( &m_matProj, D3DX_PI / 4, 1.0f, 1.0f, 100.0f );
	pd3dDevice->SetTransform( D3DTS_PROJECTION, &m_matProj );
	pd3dDevice->SetViewport( &vp );

	pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );
	pd3dDevice->SetRenderState( D3DRS_FILLMODE, D3DFILL_WIREFRAME );

	D3DXCreateFont(pd3dDevice, 20, 0, FW_NORMAL, 1, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Arial", &Font);

	//Collider
	D3DXCreateBox( pd3dDevice, 1.0f, 1.0f, 1.0f, &Cube[0].m_pMesh, NULL );
	D3DXCreateBox( pd3dDevice, 1.0f, 1.0f, 1.0f, &Cube[1].m_pMesh, NULL );

	D3DXVECTOR3 *pVertices;

	Cube[0].m_pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pVertices);
	D3DXComputeBoundingBox( pVertices, Cube[0].m_pMesh->GetNumVertices(), Cube[0].m_pMesh->GetNumBytesPerVertex(), &m_vMin0, &m_vMax0 );
	Cube[0].m_pMesh->UnlockVertexBuffer();

	Cube[1].m_pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pVertices);
	D3DXComputeBoundingBox( pVertices, Cube[1].m_pMesh->GetNumVertices(), Cube[1].m_pMesh->GetNumBytesPerVertex(), &m_vMin1, &m_vMax1 );
	Cube[1].m_pMesh->UnlockVertexBuffer();

	Cube[0].fScaling = 2.0f;
	Cube[0].vTrans = D3DXVECTOR3( -3.0f, 0.0f, 0.0f );

	Cube[1].fScaling = 4.0f;
	Cube[1].vTrans = D3DXVECTOR3( 4.0f, 0.0f, 0.0f );

	isCrash=false;
}

void GameMain::OnRender()
{	
	D3DXMATRIX matWorld, matScale, matTrans;

	char string[20];
	RECT rt = {10, 10, 0, 0};
	if(isCrash)
		sprintf(string, "Crash : TRUE");
	else
		sprintf(string, "Crash : FALSE");
	Font->DrawText(NULL, string, -1, &rt, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f));


	for(int i=0; i<2; i++)
	{
		D3DXMatrixTranslation(&matTrans, Cube[i].vTrans.x, Cube[i].vTrans.y, Cube[i].vTrans.z);
		D3DXMatrixScaling(&matScale, Cube[i].fScaling, Cube[i].fScaling, Cube[i].fScaling);
		matWorld = matScale * matTrans;
		pd3dDevice->SetTransform(D3DTS_WORLD, &matWorld);
		Cube[i].m_pMesh->DrawSubset(0);

		if(i==0)
		{
			D3DXVec3TransformCoord( &Cube[0].vMin, &m_vMin0, &matWorld );
			D3DXVec3TransformCoord( &Cube[0].vMax, &m_vMax0, &matWorld );
		}
		else
		{
			D3DXVec3TransformCoord( &Cube[1].vMin, &m_vMin1, &matWorld );
			D3DXVec3TransformCoord( &Cube[1].vMax, &m_vMax1, &matWorld );
		}
	}
}

void GameMain::OnUpdate()
{
	Key_Update();
	isCrash=Cube[0].CheckIntersect(Cube[1]);
}

void GameMain::OnRelease()
{
	//m_Shape.OnRelease();
	if(Font)
		Font->Release();
}
